open Spoc
  
open Kernel
  
open Spoc.Kernel
  
let kernel_gpuPi ((spoc_var0 : ('spoc_r, 'spoc_s) Vector.vector),
                  (spoc_var1 : ('spoc_c, 'spoc_d) Vector.vector),
                  (spoc_var2 : int), (spoc_var3 : float))
                 =
  Spoc.Kernel.exec
    [| Spoc.Kernel.VCustom (Spoc.Kernel.relax_vector spoc_var0);
      Spoc.Kernel.VFloat32 (Spoc.Kernel.relax_vector spoc_var1);
      Spoc.Kernel.Int32 spoc_var2; Spoc.Kernel.Float64 spoc_var3
    |]
  
class ['a, 'b] class_kernel_gpuPi =
  object (self)
    inherit
      [(((point, point) Vector.vector) *
        ((float, Bigarray.float32_elt) Vector.vector) * int * float),
        (('a, 'b) Kernel.kernelArgs) array] Spoc.Kernel.spoc_kernel
        "kernels/CustomPi" "pi"
    method exec = kernel_gpuPi
    method args_to_list =
      fun
        ((spoc_var0 : ('spoc_r, 'spoc_s) Vector.vector),
         (spoc_var1 : ('spoc_c, 'spoc_d) Vector.vector), (spoc_var2 : int),
         (spoc_var3 : float))
        ->
        [| Spoc.Kernel.VCustom (Spoc.Kernel.relax_vector spoc_var0);
          Spoc.Kernel.VFloat32 (Spoc.Kernel.relax_vector spoc_var1);
          Spoc.Kernel.Int32 spoc_var2; Spoc.Kernel.Float64 spoc_var3
        |]
    method list_to_args =
      function
      | [| VCustom spoc_var0; VFloat32 spoc_var1; Int32 spoc_var2;
          Float64 spoc_var3 |] ->
          ((spoc_var0 : (point, point) Vector.vector),
           (Spoc.Kernel.relax_vector spoc_var1 :
             (float, Bigarray.float32_elt) Vector.vector),
           (spoc_var2 : int), (spoc_var3 : float))
      | _ -> failwith "spoc_kernel_extension error"
  end
  
let gpuPi = new class_kernel_gpuPi
  

